import os

import axipy
from PySide2.QtGui import QIcon
from axipy import Plugin, Position, ObserverManager, view_manager

#from RegisterVector.ui.addTools.observer import factoryObserverMapAndTab
#from RegisterVector.ui.dlgMainRegisterVector import RegisterVector
#from RegisterVector.ui.dlgPacketTransform import DlgPacketTransfromTab
from SmothingGeometry.ui.addTools.observer import factoryObserverTabVector
from SmothingGeometry.ui.dlgSmothingGeometry import formSmothing
from SmothingGeometry.ui.docWidget import AxiDocWidget, addDoc, existDocWidget, DelDocWidget


class PluginSmothGeometry(Plugin):
    def __init__(self) -> None:
        self.__form_tool = None
        self.__docWidget = None
        self.__name="Сглаживание геометрии"


        self.__observer=ObserverManager.SelectionEditableIsSame
        self.__observer.changed.connect(self.__changeValueObserver)
        self.__name_observer=self.__observer.name
        self._title = self.tr("Сглаживание геометрии")

        local_file_icon_1 = os.path.join(os.path.dirname(os.path.realpath(__file__)), 'icons', 'smoothlines_32x32.png')

        self.__action_smothing = self.create_action('Сглаживание',
                                           icon=local_file_icon_1, on_click=self.run_smothing,
                                           enable_on=self.__name_observer)

        position = Position('Дополнительно', 'Действие')
        position.add(self.__action_smothing)

    def unload(self):
        if self.__docWidget is not None:
            DelDocWidget(view_manager.global_parent, self.__docWidget)
            # self.__observer.removeChildrenWidget(self.__name_observer)

            self.__docWidget = None
            self.__form_tool = None

        self.__action_smothing.remove()

    def run_smothing(self):
        if self.__form_tool is None:
            self.__form_tool =formSmothing(view_manager.global_parent)

        if self.__docWidget is None:

            self.__docWidget=AxiDocWidget(self.__form_tool.widget,"Сглаживание геометрии",self.__name,QIcon(),view_manager.global_parent)
            addDoc(axipy.app.mainwindow.qt_object(),self.__docWidget)
        else:
            isExist=existDocWidget(view_manager.global_parent,self.__docWidget)
            self.__docWidget.setVisible(True)
            self.__docWidget.setFocus()
            self.__docWidget.raise_()
    def __changeValueObserver(self):
        value_observer=self.__observer.value
        if self.__form_tool is not None:
            if not value_observer:

                self.__form_tool.widget.setEnabled(False)
            else:
                self.__form_tool.widget.setEnabled(True)

