from PySide2.QtCore import Signal
from PySide2.QtWidgets import QWidget
from axipy import selection_manager, AxipyAnyCallableTask, task_manager

from SmothingGeometry.ui.helperUI import load_ui
from SmothingGeometry.ui.tool_smothing.taskSmothing import smothTask
from SmothingGeometry.ui.tool_smothing.tool_proc_smothing import smoth_points_Chaikin, spline_smoth_points


class formSmothing(QWidget):
    cancel_signal=Signal()

    def __init__(self,parent=None):
        super().__init__(parent)
        self.ui=load_ui("DlgSmothing.ui",parent)
        self.ui.pb_run.clicked.connect(self.__run)
        self.ui.pb_cancel.clicked.connect(self.__cancel_task)
        self.ui.cmb_method.currentIndexChanged.connect(self.__change_method)
        self.__last_coef_simple=1.5
        self.__last_coef_cubic = 5
        self.ui.dSpinBox_coef.setMinimum(1.5)
        self.ui.dSpinBox_coef.setMaximum(7)
        self.ui.dSpinBox_coef.setValue(self.__last_coef_simple)
    def show(self):
        self.ui.show()
    @property
    def widget(self):
        return self.ui
    def __run(self):
        value_coef=self.ui.dSpinBox_coef.value()

        id_methos=self.ui.cmb_method.currentIndex()
        func_method=smoth_points_Chaikin
        if id_methos==1:
            func_method=spline_smoth_points
        tab_select=selection_manager.get_as_table()
        count_rec=tab_select.count()
        self.setMaxValue(count_rec)
        self.ui.pb_cancel.setEnabled(True)
        self.ui.pb_run.setEnabled(False)
        self.__tasksmoth=smothTask(tab_select,func_method,value_coef)
        self.__tasksmoth.finish_task.connect(self.__finish)
        self.__tasksmoth.update_progress.connect(self.setValue)
        self.__task = AxipyAnyCallableTask(self.__tasksmoth.run, self)
        self.__task.with_handler(True)
        task_manager.start_task(self.__task)
    def setMaxValue(self,max_value):
        self.ui.progressBar.setMaximum(max_value)
    def setValue(self,value):
        self.ui.progressBar.setValue(value)
    def __finish(self):
        self.__tasksmoth.finish_task.disconnect(self.__finish)
        self.__tasksmoth.update_progress.disconnect(self.setValue)
        self.__tasksmoth=None
        self.ui.pb_cancel.setEnabled(False)
        self.ui.pb_run.setEnabled(True)
    def __cancel_task(self):
        self.cancel_signal.emit()
    def __change_method(self,index):
        if index==0:
            self.__last_coef_cubic=self.ui.dSpinBox_coef.value()
            self.ui.dSpinBox_coef.setMinimum(1.5)
            self.ui.dSpinBox_coef.setMaximum(7)
            self.ui.dSpinBox_coef.setValue(self.__last_coef_simple)
        if index==1:
            self.__last_coef_simple = self.ui.dSpinBox_coef.value()
            self.ui.dSpinBox_coef.setMinimum(3)
            self.ui.dSpinBox_coef.setMaximum(12)
            self.ui.dSpinBox_coef.setValue(self.__last_coef_cubic)


