from axipy import CoordSystem, Geometry, Unit, Feature
from osgeo import ogr, gdal


def prepareContour(source_band, out_srs,layer_contour,levels):
    res_driver = ogr.GetDriverByName('MEMORY')
    res_ds = res_driver.CreateDataSource('result')
    res_open = res_driver.Open('result',1)
    res_layer = res_ds.CreateLayer('result', out_srs, ogr.wkbPolygon)
    mask=source_band.GetMaskBand()
    gdal.Polygonize( source_band,mask, res_layer, -1, [], callback=None )
    ''' Объедияем все объекты в один'''
    geo_bound=None
    count_row=res_layer.GetFeatureCount()
    for i in range(count_row):
        ft=res_layer.GetFeature(i)
        if ft is None:
            continue
        geometry=ft.GetGeometryRef()
        if geometry is None:
            ft=None
            continue
        if geo_bound is None:
            geo_bound=geometry.Clone()
            geometry=None
            ft=None
            continue
        geo_bound=geo_bound.Union(geometry)
        geometry=None
        ft=None
    ''' В geo_bound граница существующих значений'''
    count_contour=layer_contour.GetFeatureCount()
    for i in range(count_contour):
        ft=layer_contour.GetFeature(i)
        if ft is None:
            continue
        geometry=ft.GetGeometryRef()
        if geometry is None:
            ft=None
            continue
        geo_bound=geo_bound.Difference(geometry)
        geometry=None
        ft=None
    ''' По идее должны получить регионы которых нет в контурах '''
    count_poly=geo_bound.GetGeometryCount()
    for i in range(count_poly):
        temp_poly=geo_bound.GetGeometryRef(i)
        is_valid=temp_poly.IsValid()
        area=temp_poly.Area()
        geo_buf=temp_poly.Buffer(0.0)
        jkl=0
    return
def prepareContourAxiPy(source_band, out_srs,layer_contour,levels,tab_temp):
    res_driver = ogr.GetDriverByName('MEMORY')
    res_ds = res_driver.CreateDataSource('result')
    res_open = res_driver.Open('result',1)
    res_layer = res_ds.CreateLayer('result', out_srs, ogr.wkbPolygon)
    mask=source_band.GetMaskBand()
    gdal.Polygonize( source_band,mask, res_layer, -1, [], callback=None )
    ''' Объедияем все объекты в один'''
    geo_bound=None
    wkt_cs=out_srs.ExportToWkt()
    cs_axipy=CoordSystem.from_wkt(wkt_cs)
    count_row=res_layer.GetFeatureCount()
    for i in range(count_row):
        ft=res_layer.GetFeature(i)
        if ft is None:
            continue
        geometry=ft.GetGeometryRef()
        if geometry is None:
            ft=None
            continue
        axi_geo=Geometry.from_wkb(geometry.ExportToWkb(),cs_axipy)
        if geo_bound is None:
            #geo_bound=geometry.Clone()
            geo_bound=axi_geo.clone()
            geometry=None
            ft=None
            continue
        geo_bound=geo_bound.union(axi_geo)
        geometry=None
        ft=None
    ''' В geo_bound граница существующих значений'''
    #count_poly=geo_bound.GetGeometryCount()

    #axy_geo_bound=Geometry.from_wkb(geo_bound.ExportToWkb(),cs_axipy)
    ft=Feature({'id':-1},geometry=geo_bound)
    tab_temp.insert([ft])
    axy_geo_bound=geo_bound
    count_poly=len(axy_geo_bound)
    count_contour=layer_contour.GetFeatureCount()
    for i in range(count_contour):
        ft=layer_contour.GetFeature(i)
        if ft is None:
            continue
        geometry=ft.GetGeometryRef()
        if geometry is None:
            ft=None
            continue
        geo_axi=Geometry.from_wkb(geometry.ExportToWkb(),cs_axipy)
        axy_geo_bound=axy_geo_bound.difference(geo_axi)
        geometry=None
        ft=None
    ''' По идее должны получить регионы которых нет в контурах '''
    #count_poly=geo_bound.GetGeometryCount()
    #wkt_cs=out_srs.ExportToWkt()
    #cs_axipy=CoordSystem.from_wkt(wkt_cs)
    #axy_geo=Geometry.from_wkb(geo_bound.ExportToWkb(),cs_axipy)
    ft=Feature({'id':0},geometry=axy_geo_bound)
    tab_temp.insert([ft])
    axy_geo=axy_geo_bound
    count_poly=len(axy_geo)
    jkl=0
    for i in range(count_poly):
        temp_poly=axy_geo[i]
        is_valid=temp_poly.is_valid
        area=temp_poly.get_area(Unit.sq_m)
        #geo_buf=temp_poly.Buffer(0.0)
        jkl=0
    return



