import numpy as np
import matplotlib.pyplot as plt
from scipy.interpolate import interp1d
def scipySmoth(points,coef,name='cubic'):
    x=[]
    y=[]
    for pnt in points:
        x.append(pnt[0])
        y.append(pnt[1])
    orig_len = len(x)
    x = x[-3:-1] + x + x[1:3]
    y = y[-3:-1] + y + y[1:3]

    t = np.arange(len(x))
    new_count=int(coef * orig_len+0.5)
    ti = np.linspace(2, orig_len + 1,new_count)

    xi = interp1d(t, x, kind=name)(ti)
    yi = interp1d(t, y, kind=name)(ti)
    out_points=[]
    for i in range(len(xi)):
        out_points.append((xi[i],yi[i]))
    return out_points