import time

from PySide2.QtCore import QObject, Signal
from axipy import AxipyProgressHandler

from SmothingGeometry.ui.tool_smothing.helper_smoth import CacheTableUpdate
from SmothingGeometry.ui.tool_smothing.tool_proc_smothing import smoth_geometry


class smothTask(QObject):
    finish_task = Signal()
    update_progress=Signal(int)
    def __init__(self,tab_selection,method_smoth,coef):
        super().__init__()
        self.__tab=tab_selection
        self.__method=method_smoth
        self.__coef=coef
        self.__cls_cache_tab = CacheTableUpdate(self.__tab, 1000)
        self.__count = self.__tab.count()
    def run(self,ph: AxipyProgressHandler,cls_progessBar):
        cls_progessBar.cancel_signal.connect(self.__set_cancel)

        #cls_progessBar.setMaxValue(self.__count)
        self.__ph = ph
        ph.set_max_progress(self.__count)
        for i, ft in enumerate(self.__tab.items()):
            print(i)
            if ph.is_canceled():
                break
            ph.add_progress(1)
            self.update_progress.emit(i + 1)
            if ft.geometry is None:
                continue
            print(i)

            new_geo = smoth_geometry(ft.geometry, self.__coef, self.__method)
            if new_geo is None:
                continue
            ft.geometry = new_geo
            self.__cls_cache_tab.add(ft)
            #time.sleep(1)
        self.__cls_cache_tab.end()
        print("End")
        self.finish_task.emit()
        return ph.progress()
    def __set_cancel(self):
        self.__ph.cancel()
