from axipy import Geometry, Point, Line, Text, Ellipse, Arc, MultiPoint, LineString, Polygon, ListPoint, \
    MultiLineString, GeometryCollection

from SmothingGeometry.ui.tool_smothing.Chaikins_smoth import Object
from SmothingGeometry.ui.tool_smothing.SmothCubic import scipySmoth


def listPntToTuple(list_point):
    list_uple_xy=[]
    for pnt in list_point:
        list_uple_xy.append((pnt.x,pnt.y))
    return list_uple_xy
def smoth_points_Chaikin(points:ListPoint,coef):
    count=len(points)
    isClose = False
    if points[0] == points[count - 1]:
        isClose = True
    pnts = listPntToTuple(points)
    obj_points = Object(pnts)
    new_points = obj_points.Smooth_by_Chaikin(coef)
    if not isClose:
        new_points.insert(0, pnts[0])
        new_points.append(pnts[-1])
    return new_points
def spline_smoth_points(points:ListPoint,coef):
    new_points = scipySmoth(listPntToTuple(points), coef)
    return new_points
def smoth_polyline(geo:LineString,coef,func_smoth)->Geometry:
    points=geo.points
    count=len(points)
    if count<3:
        return None
    new_points= func_smoth(points,coef)
    return LineString(new_points,geo.coordsystem)
def smoth_polygon_simple(geo:Polygon,coef,func_smoth)->Geometry:
    new_points=func_smoth(geo.points,coef)
    return Polygon(new_points,geo.coordsystem)
def smoth_polygon(geo:Polygon,coef,func_smoth)->Geometry:
    holes=geo.holes
    if len(holes)==0:
        ''' Простой полигон'''
        return smoth_polygon_simple(geo,coef,func_smoth)
    new_polygon=smoth_polygon_simple(geo,coef,func_smoth)
    for hole_points in holes:
        new_points_hole=func_smoth(hole_points,coef)
        new_polygon.holes.append(new_points_hole)
    return new_polygon
def smoth_geometry(geo:Geometry,coef,func_smoth)->Geometry:
    if geo is None :
        return None
    if isinstance(geo,Point):
        return None
    if isinstance(geo,Line):
        return None
    if isinstance(geo,Text):
        return None
    if isinstance(geo,Ellipse):
        return None
    if isinstance(geo,Arc):
        return None
    if isinstance(geo,MultiPoint):
        return None
    if isinstance(geo,LineString):
        return smoth_polyline(geo,coef,func_smoth)
    if isinstance(geo,Polygon):
        return smoth_polygon(geo,coef,func_smoth)
    if isinstance(geo,GeometryCollection):
        list_geometry=[]
        count_update_geometry=0
        for geo_item in geo:
            new_geo=smoth_geometry(geo_item,coef,func_smoth)
            if new_geo is not None:
                count_update_geometry=count_update_geometry+1
                list_geometry.append(new_geo)
            else:
                list_geometry.append(geo_item)
        if count_update_geometry==0:
            return None
        new_geo_coll=GeometryCollection(cs=geo.coordsystem)
        for geo_item in list_geometry:
            new_geo_coll.append(geo_item)
        return new_geo_coll






